/*
 * Copyright (C) 2020  CZ.NIC, z. s. p. o.
 *
 * This file is part of FRED.
 *
 * FRED is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * FRED is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with FRED.  If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef ABOUT_REPLY_HH_2725E0B499C54568931F906328B6F99E
#define ABOUT_REPLY_HH_2725E0B499C54568931F906328B6F99E

#include "libdiagnostics/service_name.hh"

#include <map>
#include <string>

namespace Fred {
namespace LibDiagnostics {

struct AboutReply
{
    // TODO use strong types from library
    using ServerVersion = std::string;
    using ApiVersion = std::string;

    ServerVersion server_version;
    std::map<ServiceName, ApiVersion> api_versions;
};

} // namespace Fred::LibDiagnostics
} // namespace Fred

#endif
