/*
 * Copyright (C) 2021  CZ.NIC, z. s. p. o.
 *
 * This file is part of FRED.
 *
 * FRED is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * FRED is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with FRED.  If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef GET_DOMAINS_BY_HOLDER_REPLY_HH_5F79D563B62B793EE2B8011F824089CF//date "+%s.%N"|md5sum|tr "[a-f]" "[A-F]"
#define GET_DOMAINS_BY_HOLDER_REPLY_HH_5F79D563B62B793EE2B8011F824089CF

#include "src/contact/contact_common_types.hh"
#include "src/domain/domain_common_types.hh"
#include "src/domain/get_domains_by_holder_request.hh"
#include "src/util/printable.hh"
#include "src/exceptions.hh"

#include <string>
#include <vector>

namespace Fred {
namespace Registry {
namespace Domain {

struct GetDomainsByHolderReply
{
    struct Data : Util::Printable<Data>
    {
        struct Domain : Util::Printable<Domain>
        {
            DomainId domain_id;
            DomainHistoryId domain_history_id;
            Fqdn fqdn;
            std::string to_string() const;
        };
        Contact::ContactId domain_holder_id; // implementation should fill it only in the first (streamed) response
        Contact::ContactHistoryId domain_holder_history_id; // implementation should fill it only in the first (streamed) response
        std::vector<Domain> domains;
        std::string to_string() const;
    };
    struct Exception
    {
        struct DomainHolderDoesNotExist : Registry::Exception
        {
            explicit DomainHolderDoesNotExist(const GetDomainsByHolderRequest& src);
        };
    };
};

} // namespace Fred::Registry::Domain
} // namespace Fred::Registry
} // namespace Fred

#endif//GET_DOMAINS_BY_HOLDER_REPLY_HH_5F79D563B62B793EE2B8011F824089CF
