/*
 * Copyright (C) 2019-2022  CZ.NIC, z. s. p. o.
 *
 * This file is part of FRED.
 *
 * FRED is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * FRED is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with FRED.  If not, see <https://www.gnu.org/licenses/>.
 */

#include "src/keyset/keyset_info_request.hh"

#include "src/util/struct_to_string.hh"

#include <string>

namespace Fred {
namespace Registry {
namespace Keyset {

std::string KeysetInfoRequest::to_string() const
{
    return Util::StructToString().add("keyset_id", keyset_id)
                                 .add("keyset_history_id", keyset_history_id)
                                 .finish();
}

std::string KeysetIdRequest::to_string() const
{
    return Util::StructToString().add("keyset_handle", keyset_handle)
                                 .finish();
}

} // namespace Fred::Registry::Keyset
} // namespace Fred::Registry
} // namespace Fred
