/*
 * Copyright (C) 2019-2022  CZ.NIC, z. s. p. o.
 *
 * This file is part of FRED.
 *
 * FRED is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * FRED is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with FRED.  If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef PROTO_WRAP_HH_DFD8AE33A7CF17F901177987E210122D//date "+%s.%N"|md5sum|tr "[a-f]" "[A-F]"
#define PROTO_WRAP_HH_DFD8AE33A7CF17F901177987E210122D

#include "src/contact/contact_data_history.hh"
#include "src/contact/contact_handle_history.hh"
#include "src/contact/contact_state.hh"
#include "src/contact/contact_state_flags.hh"
#include "src/contact/contact_state_history.hh"
#include "src/contact/contact_info.hh"
#include "src/contact/search_contact.hh"
#include "src/contact/update_contact.hh"

#include "src/domain/batch_delete_domains_reply.hh"
#include "src/domain/domain_data_history.hh"
#include "src/domain/domain_info_reply.hh"
#include "src/domain/domain_state.hh"
#include "src/domain/domain_state_flags.hh"
#include "src/domain/domain_state_history.hh"
#include "src/domain/fqdn_history.hh"
#include "src/domain/get_domains_by_contact_reply.hh"
#include "src/domain/get_domains_by_holder_reply.hh"
#include "src/domain/get_domains_notify_info_reply.hh"
#include "src/domain/manage_domain_state_flags_reply.hh"
#include "src/domain/search_domain.hh"
#include "src/domain/update_domains_additional_notify_info_reply.hh"

#include "src/keyset/keyset_data_history.hh"
#include "src/keyset/keyset_info_reply.hh"
#include "src/keyset/keyset_handle_history.hh"
#include "src/keyset/keyset_state.hh"
#include "src/keyset/keyset_state_flags.hh"
#include "src/keyset/keyset_state_history.hh"
#include "src/keyset/keyset_info.hh"
#include "src/keyset/search_keyset.hh"

#include "src/log_entry_id.hh"

#include "src/nsset/nsset_data_history.hh"
#include "src/nsset/nsset_info_reply.hh"
#include "src/nsset/nsset_handle_history.hh"
#include "src/nsset/nsset_state.hh"
#include "src/nsset/nsset_state_flags.hh"
#include "src/nsset/nsset_state_history.hh"
#include "src/nsset/nsset_info.hh"
#include "src/nsset/search_nsset.hh"

#include "src/registrar/registrar_credit.hh"
#include "src/registrar/registrar_info.hh"
#include "src/registrar/registrar_list.hh"
#include "src/registrar/registrar_zone_access.hh"

#include "src/registry_type_traits.hh"

#include "fred_api/registry/common_types.pb.h"

#include "fred_api/registry/contact/contact_common_types.pb.h"
#include "fred_api/registry/contact/contact_handle_history_types.pb.h"
#include "fred_api/registry/contact/contact_history_types.pb.h"
#include "fred_api/registry/contact/contact_info_types.pb.h"
#include "fred_api/registry/contact/contact_state_flags_types.pb.h"
#include "fred_api/registry/contact/contact_state_history_types.pb.h"
#include "fred_api/registry/contact/contact_state_types.pb.h"
#include "fred_api/registry/contact/update_contact_types.pb.h"
#include "fred_api/registry/contact/service_contact_grpc.grpc.pb.h"
#include "fred_api/registry/contact/service_contact_grpc.pb.h"
#include "fred_api/registry/contact/service_search_contact_grpc.pb.h"
#include "fred_api/registry/contact/service_search_contact_grpc.grpc.pb.h"

#include "fred_api/registry/domain/domain_common_types.pb.h"
#include "fred_api/registry/domain/domain_history_types.pb.h"
#include "fred_api/registry/domain/domain_info_types.pb.h"
#include "fred_api/registry/domain/domain_state_flags_types.pb.h"
#include "fred_api/registry/domain/domain_state_history_types.pb.h"
#include "fred_api/registry/domain/domain_state_types.pb.h"
#include "fred_api/registry/domain/fqdn_history_types.pb.h"
#include "fred_api/registry/domain/service_admin_grpc.pb.h"
#include "fred_api/registry/domain/service_admin_grpc.grpc.pb.h"
#include "fred_api/registry/domain/service_domain_grpc.pb.h"
#include "fred_api/registry/domain/service_domain_grpc.grpc.pb.h"
#include "fred_api/registry/domain/service_search_domain_grpc.pb.h"
#include "fred_api/registry/domain/service_search_domain_grpc.grpc.pb.h"

#include "fred_api/registry/keyset/keyset_common_types.pb.h"
#include "fred_api/registry/keyset/keyset_handle_history_types.pb.h"
#include "fred_api/registry/keyset/keyset_history_types.pb.h"
#include "fred_api/registry/keyset/keyset_info_types.pb.h"
#include "fred_api/registry/keyset/keyset_state_flags_types.pb.h"
#include "fred_api/registry/keyset/keyset_state_history_types.pb.h"
#include "fred_api/registry/keyset/keyset_state_types.pb.h"
#include "fred_api/registry/keyset/service_keyset_grpc.grpc.pb.h"
#include "fred_api/registry/keyset/service_keyset_grpc.pb.h"
#include "fred_api/registry/keyset/service_search_keyset_grpc.pb.h"
#include "fred_api/registry/keyset/service_search_keyset_grpc.grpc.pb.h"

#include "fred_api/registry/nsset/nsset_common_types.pb.h"
#include "fred_api/registry/nsset/nsset_handle_history_types.pb.h"
#include "fred_api/registry/nsset/nsset_history_types.pb.h"
#include "fred_api/registry/nsset/nsset_info_types.pb.h"
#include "fred_api/registry/nsset/nsset_state_flags_types.pb.h"
#include "fred_api/registry/nsset/nsset_state_history_types.pb.h"
#include "fred_api/registry/nsset/nsset_state_types.pb.h"
#include "fred_api/registry/nsset/service_nsset_grpc.pb.h"
#include "fred_api/registry/nsset/service_nsset_grpc.grpc.pb.h"
#include "fred_api/registry/nsset/service_search_nsset_grpc.pb.h"
#include "fred_api/registry/nsset/service_search_nsset_grpc.grpc.pb.h"

#include "fred_api/registry/registrar/service_registrar_grpc.pb.h"
#include "fred_api/registry/registrar/service_registrar_grpc.grpc.pb.h"


namespace Fred {
namespace Registry {

template <typename T>
void proto_wrap(const T& src, typename RegistryTypeTraits<T>::ProtoType* dst);

template <>
struct RegistryTypeTraits<LogEntryId>
{
    using ProtoType = Api::LogEntryId;
};

template <>
struct RegistryTypeTraits<Contact::ContactInfoReply::Data>
{
    using ProtoType = Api::Contact::ContactInfoReply;
};

template <>
struct RegistryTypeTraits<Contact::InternalServerError>
{
    using ProtoType = Api::Contact::ContactInfoReply;
};

template <>
struct RegistryTypeTraits<Contact::ContactInfoReply::Exception::ContactDoesNotExist>
{
    using ProtoType = Api::Contact::ContactInfoReply;
};

template <>
struct RegistryTypeTraits<Contact::ContactIdReply::Data>
{
    using ProtoType = Api::Contact::ContactIdReply;
};

template <>
struct RegistryTypeTraits<Contact::ContactIdReply::Exception::ContactDoesNotExist>
{
    using ProtoType = Api::Contact::ContactIdReply;
};

template <>
struct RegistryTypeTraits<Contact::ContactDataHistoryReply::Data>
{
    using ProtoType = Api::Contact::ContactHistoryReply;
};

template <>
struct RegistryTypeTraits<Contact::ContactDataHistoryReply::Exception::ContactDoesNotExist>
{
    using ProtoType = Api::Contact::ContactHistoryReply;
};

template <>
struct RegistryTypeTraits<Contact::ContactDataHistoryReply::Exception::InvalidHistoryInterval>
{
    using ProtoType = Api::Contact::ContactHistoryReply;
};

template <>
struct RegistryTypeTraits<Contact::ContactHandleHistoryReply::Data>
{
    using ProtoType = Api::Contact::ContactHandleHistoryReply;
};

template <>
struct RegistryTypeTraits<Contact::ContactStateFlagsInfo>
{
    using ProtoType = Api::Contact::ContactStateFlagsReply;
};

template <>
struct RegistryTypeTraits<Contact::ContactStateReply::Data>
{
    using ProtoType = Api::Contact::ContactStateReply;
};

template <>
struct RegistryTypeTraits<Contact::ContactStateReply::Exception::ContactDoesNotExist>
{
    using ProtoType = Api::Contact::ContactStateReply;
};

template <>
struct RegistryTypeTraits<Contact::ContactStateHistoryReply::Data>
{
    using ProtoType = Api::Contact::ContactStateHistoryReply;
};

template <>
struct RegistryTypeTraits<Contact::ContactStateHistoryReply::Exception::ContactDoesNotExist>
{
    using ProtoType = Api::Contact::ContactStateHistoryReply;
};

template <>
struct RegistryTypeTraits<Contact::ContactStateHistoryReply::Exception::InvalidHistoryInterval>
{
    using ProtoType = Api::Contact::ContactStateHistoryReply;
};

template <>
struct RegistryTypeTraits<Contact::UpdateContactReply::Data>
{
    using ProtoType = Api::Contact::UpdateContactReply;
};

template <>
struct RegistryTypeTraits<Contact::UpdateContactReply::Exception::ContactDoesNotExist>
{
    using ProtoType = Api::Contact::UpdateContactReply;
};

template <>
struct RegistryTypeTraits<Contact::UpdateContactReply::Exception::NotCurrentVersion>
{
    using ProtoType = Api::Contact::UpdateContactReply;
};

template <>
struct RegistryTypeTraits<Contact::SearchContactReply::Data>
{
    using ProtoType = Api::Contact::SearchContactReply;
};

template <>
struct RegistryTypeTraits<Contact::SearchContactHistoryReply::Data>
{
    using ProtoType = Api::Contact::SearchContactHistoryReply;
};

template <>
struct RegistryTypeTraits<Contact::SearchContactHistoryReply::Exception::ChronologyViolation>
{
    using ProtoType = Api::Contact::SearchContactHistoryReply;
};

template <>
struct RegistryTypeTraits<Keyset::KeysetInfoReply::Data>
{
    using ProtoType = Api::Keyset::KeysetInfoReply;
};

template <>
struct RegistryTypeTraits<Keyset::InternalServerError>
{
    using ProtoType = Api::Keyset::KeysetInfoReply;
};

template <>
struct RegistryTypeTraits<Keyset::KeysetInfoReply::Exception::KeysetDoesNotExist>
{
    using ProtoType = Api::Keyset::KeysetInfoReply;
};

template <>
struct RegistryTypeTraits<Keyset::KeysetIdReply::Data>
{
    using ProtoType = Api::Keyset::KeysetIdReply;
};

template <>
struct RegistryTypeTraits<Keyset::KeysetIdReply::Exception::KeysetDoesNotExist>
{
    using ProtoType = Api::Keyset::KeysetIdReply;
};

template <>
struct RegistryTypeTraits<Keyset::KeysetDataHistoryReply::Data>
{
    using ProtoType = Api::Keyset::KeysetHistoryReply;
};

template <>
struct RegistryTypeTraits<Keyset::KeysetDataHistoryReply::Exception::KeysetDoesNotExist>
{
    using ProtoType = Api::Keyset::KeysetHistoryReply;
};

template <>
struct RegistryTypeTraits<Keyset::KeysetDataHistoryReply::Exception::InvalidHistoryInterval>
{
    using ProtoType = Api::Keyset::KeysetHistoryReply;
};

template <>
struct RegistryTypeTraits<Keyset::KeysetHandleHistoryReply::Data>
{
    using ProtoType = Api::Keyset::KeysetHandleHistoryReply;
};

template <>
struct RegistryTypeTraits<Keyset::KeysetStateFlagsInfo>
{
    using ProtoType = Api::Keyset::KeysetStateFlagsReply;
};

template <>
struct RegistryTypeTraits<Keyset::KeysetStateReply::Data>
{
    using ProtoType = Api::Keyset::KeysetStateReply;
};

template <>
struct RegistryTypeTraits<Keyset::KeysetStateReply::Exception::KeysetDoesNotExist>
{
    using ProtoType = Api::Keyset::KeysetStateReply;
};

template <>
struct RegistryTypeTraits<Keyset::KeysetStateHistoryReply::Data>
{
    using ProtoType = Api::Keyset::KeysetStateHistoryReply;
};

template <>
struct RegistryTypeTraits<Keyset::KeysetStateHistoryReply::Exception::KeysetDoesNotExist>
{
    using ProtoType = Api::Keyset::KeysetStateHistoryReply;
};

template <>
struct RegistryTypeTraits<Keyset::KeysetStateHistoryReply::Exception::InvalidHistoryInterval>
{
    using ProtoType = Api::Keyset::KeysetStateHistoryReply;
};

template <>
struct RegistryTypeTraits<Keyset::SearchKeysetReply::Data>
{
    using ProtoType = Api::Keyset::SearchKeysetReply;
};

template <>
struct RegistryTypeTraits<Keyset::SearchKeysetHistoryReply::Data>
{
    using ProtoType = Api::Keyset::SearchKeysetHistoryReply;
};

template <>
struct RegistryTypeTraits<Keyset::SearchKeysetHistoryReply::Exception::ChronologyViolation>
{
    using ProtoType = Api::Keyset::SearchKeysetHistoryReply;
};

template <>
struct RegistryTypeTraits<Nsset::NssetInfoReply::Data>
{
    using ProtoType = Api::Nsset::NssetInfoReply;
};

template <>
struct RegistryTypeTraits<Nsset::InternalServerError>
{
    using ProtoType = Api::Nsset::NssetInfoReply;
};

template <>
struct RegistryTypeTraits<Nsset::NssetInfoReply::Exception::NssetDoesNotExist>
{
    using ProtoType = Api::Nsset::NssetInfoReply;
};

template <>
struct RegistryTypeTraits<Nsset::NssetIdReply::Data>
{
    using ProtoType = Api::Nsset::NssetIdReply;
};

template <>
struct RegistryTypeTraits<Nsset::NssetIdReply::Exception::NssetDoesNotExist>
{
    using ProtoType = Api::Nsset::NssetIdReply;
};

template <>
struct RegistryTypeTraits<Nsset::NssetDataHistoryReply::Data>
{
    using ProtoType = Api::Nsset::NssetHistoryReply;
};

template <>
struct RegistryTypeTraits<Nsset::NssetDataHistoryReply::Exception::NssetDoesNotExist>
{
    using ProtoType = Api::Nsset::NssetHistoryReply;
};

template <>
struct RegistryTypeTraits<Nsset::NssetDataHistoryReply::Exception::InvalidHistoryInterval>
{
    using ProtoType = Api::Nsset::NssetHistoryReply;
};

template <>
struct RegistryTypeTraits<Nsset::NssetHandleHistoryReply::Data>
{
    using ProtoType = Api::Nsset::NssetHandleHistoryReply;
};

template <>
struct RegistryTypeTraits<Nsset::NssetStateFlagsInfo>
{
    using ProtoType = Api::Nsset::NssetStateFlagsReply;
};

template <>
struct RegistryTypeTraits<Nsset::NssetStateReply::Data>
{
    using ProtoType = Api::Nsset::NssetStateReply;
};

template <>
struct RegistryTypeTraits<Nsset::NssetStateReply::Exception::NssetDoesNotExist>
{
    using ProtoType = Api::Nsset::NssetStateReply;
};

template <>
struct RegistryTypeTraits<Nsset::NssetStateHistoryReply::Data>
{
    using ProtoType = Api::Nsset::NssetStateHistoryReply;
};

template <>
struct RegistryTypeTraits<Nsset::NssetStateHistoryReply::Exception::NssetDoesNotExist>
{
    using ProtoType = Api::Nsset::NssetStateHistoryReply;
};

template <>
struct RegistryTypeTraits<Nsset::NssetStateHistoryReply::Exception::InvalidHistoryInterval>
{
    using ProtoType = Api::Nsset::NssetStateHistoryReply;
};

template <>
struct RegistryTypeTraits<Nsset::SearchNssetReply::Data>
{
    using ProtoType = Api::Nsset::SearchNssetReply;
};

template <>
struct RegistryTypeTraits<Nsset::SearchNssetHistoryReply::Data>
{
    using ProtoType = Api::Nsset::SearchNssetHistoryReply;
};

template <>
struct RegistryTypeTraits<Nsset::SearchNssetHistoryReply::Exception::ChronologyViolation>
{
    using ProtoType = Api::Nsset::SearchNssetHistoryReply;
};

template <>
struct RegistryTypeTraits<Domain::DomainInfoReply::Data>
{
    using ProtoType = Api::Domain::DomainInfoReply;
};

template <>
struct RegistryTypeTraits<Domain::InternalServerError>
{
    using ProtoType = Api::Domain::DomainInfoReply;
};

template <>
struct RegistryTypeTraits<Domain::DomainInfoReply::Exception::DomainDoesNotExist>
{
    using ProtoType = Api::Domain::DomainInfoReply;
};

template <>
struct RegistryTypeTraits<Domain::DomainIdReply::Data>
{
    using ProtoType = Api::Domain::DomainIdReply;
};

template <>
struct RegistryTypeTraits<Domain::DomainIdReply::Exception::DomainDoesNotExist>
{
    using ProtoType = Api::Domain::DomainIdReply;
};

template <>
struct RegistryTypeTraits<Domain::DomainDataHistoryReply::Data>
{
    using ProtoType = Api::Domain::DomainHistoryReply;
};

template <>
struct RegistryTypeTraits<Domain::DomainDataHistoryReply::Exception::DomainDoesNotExist>
{
    using ProtoType = Api::Domain::DomainHistoryReply;
};

template <>
struct RegistryTypeTraits<Domain::DomainDataHistoryReply::Exception::InvalidHistoryInterval>
{
    using ProtoType = Api::Domain::DomainHistoryReply;
};

template <>
struct RegistryTypeTraits<Domain::FqdnHistoryReply::Data>
{
    using ProtoType = Api::Domain::FqdnHistoryReply;
};

template <>
struct RegistryTypeTraits<Domain::DomainStateFlagsInfo>
{
    using ProtoType = Api::Domain::DomainStateFlagsReply;
};

template <>
struct RegistryTypeTraits<Domain::DomainStateReply::Data>
{
    using ProtoType = Api::Domain::DomainStateReply;
};

template <>
struct RegistryTypeTraits<Domain::DomainStateReply::Exception::DomainDoesNotExist>
{
    using ProtoType = Api::Domain::DomainStateReply;
};

template <>
struct RegistryTypeTraits<Domain::DomainStateHistoryReply::Data>
{
    using ProtoType = Api::Domain::DomainStateHistoryReply;
};

template <>
struct RegistryTypeTraits<Domain::DomainStateHistoryReply::Exception::DomainDoesNotExist>
{
    using ProtoType = Api::Domain::DomainStateHistoryReply;
};

template <>
struct RegistryTypeTraits<Domain::DomainStateHistoryReply::Exception::InvalidHistoryInterval>
{
    using ProtoType = Api::Domain::DomainStateHistoryReply;
};

template <>
struct RegistryTypeTraits<Domain::SearchDomainReply::Data>
{
    using ProtoType = Api::Domain::SearchDomainReply;
};

template <>
struct RegistryTypeTraits<Domain::SearchDomainHistoryReply::Data>
{
    using ProtoType = Api::Domain::SearchDomainHistoryReply;
};

template <>
struct RegistryTypeTraits<Domain::SearchDomainHistoryReply::Exception::ChronologyViolation>
{
    using ProtoType = Api::Domain::SearchDomainHistoryReply;
};

template <>
struct RegistryTypeTraits<Domain::BatchDeleteDomainsReply::NotDeleted::Reason>
{
    using ProtoType = Api::Domain::BatchDeleteDomainsReply::NotDeleted;
};

template <>
struct RegistryTypeTraits<Domain::BatchDeleteDomainsReply::NotDeleted>
{
    using ProtoType = Api::Domain::BatchDeleteDomainsReply::NotDeleted;
};

std::size_t proto_wrap(
        const Domain::BatchDeleteDomainsReply::Data& src,
        std::size_t offset,
        Api::Domain::BatchDeleteDomainsReply::Data* dst);

template <>
struct RegistryTypeTraits<Domain::ManageDomainStateFlagsReply::Data::DomainStateFlagRequestInfo>
{
    using ProtoType = Api::Domain::ManageDomainStateFlagsReply::Data::DomainStateFlagRequestInfo;
};

std::size_t proto_wrap(
        const Domain::ManageDomainStateFlagsReply::Data& src,
        std::size_t offset,
        Api::Domain::ManageDomainStateFlagsReply::Data* dst);

template <>
struct RegistryTypeTraits<Domain::ManageDomainStateFlagsReply::Exception::DomainDoesNotExist>
{
    using ProtoType = Api::Domain::ManageDomainStateFlagsReply;
};

template <>
struct RegistryTypeTraits<Domain::ManageDomainStateFlagsReply::Exception::DomainStateFlagDoesNotExist>
{
    using ProtoType = Api::Domain::ManageDomainStateFlagsReply;
};

template <>
struct RegistryTypeTraits<Domain::ManageDomainStateFlagsReply::Exception::DomainStateFlagRequestDoesNotExist>
{
    using ProtoType = Api::Domain::ManageDomainStateFlagsReply;
};

template <>
struct RegistryTypeTraits<Domain::ManageDomainStateFlagsReply::Exception::DomainHistoryIdMismatch>
{
    using ProtoType = Api::Domain::ManageDomainStateFlagsReply;
};

template <>
struct RegistryTypeTraits<Domain::GetDomainsByContactReply::Data>
{
    using ProtoType = Api::Domain::DomainsByContactReply;
};

std::size_t proto_wrap(
        const Domain::GetDomainsByContactReply::Data& src,
        std::size_t offset,
        Api::Domain::DomainsByContactReply::Data* dst);

template <>
struct RegistryTypeTraits<Domain::GetDomainsByContactReply::Exception::ContactDoesNotExist>
{
    using ProtoType = Api::Domain::DomainsByContactReply;
};

template <>
struct RegistryTypeTraits<Domain::GetDomainsByContactReply::Exception::InvalidOrderBy>
{
    using ProtoType = Api::Domain::DomainsByContactReply;
};

template <>
struct RegistryTypeTraits<Domain::GetDomainsByHolderReply::Data>
{
    using ProtoType = Api::Domain::DomainsByHolderReply;
};

std::size_t proto_wrap(
        const Domain::GetDomainsByHolderReply::Data& src,
        std::size_t offset,
        Api::Domain::DomainsByHolderReply::Data* dst);

template <>
struct RegistryTypeTraits<Domain::GetDomainsByHolderReply::Exception::DomainHolderDoesNotExist>
{
    using ProtoType = Api::Domain::DomainsByHolderReply;
};

template <>
struct RegistryTypeTraits<Domain::GetDomainsNotifyInfoReply::Data>
{
    using ProtoType = Api::Domain::GetDomainsNotifyInfoReply;
};

std::size_t proto_wrap(
        const Domain::GetDomainsNotifyInfoReply::Data& src,
        std::size_t offset,
        Api::Domain::GetDomainsNotifyInfoReply::Data* dst);

template <>
struct RegistryTypeTraits<Domain::UpdateDomainsAdditionalNotifyInfoReply::Exception::DomainDoesNotExist>
{
    using ProtoType = Api::Domain::UpdateDomainsAdditionalNotifyInfoReply;
};

template <>
struct RegistryTypeTraits<Domain::UpdateDomainsAdditionalNotifyInfoReply::Exception::InvalidDomainContactInfo>
{
    using ProtoType = Api::Domain::UpdateDomainsAdditionalNotifyInfoReply;
};

template <>
struct RegistryTypeTraits<Registrar::RegistrarCreditReply::Data>
{
    using ProtoType = Api::Registrar::RegistrarCreditReply;
};

template <>
struct RegistryTypeTraits<Registrar::RegistrarCreditReply::Exception::RegistrarDoesNotExist>
{
    using ProtoType = Api::Registrar::RegistrarCreditReply;
};

template <>
struct RegistryTypeTraits<Registrar::RegistrarInfoReply::Data>
{
    using ProtoType = Api::Registrar::RegistrarInfoReply;
};

template <>
struct RegistryTypeTraits<Registrar::RegistrarInfoReply::Exception::RegistrarDoesNotExist>
{
    using ProtoType = Api::Registrar::RegistrarInfoReply;
};

template <>
struct RegistryTypeTraits<Registrar::RegistrarListReply::Data>
{
    using ProtoType = Api::Registrar::RegistrarListReply;
};

template <>
struct RegistryTypeTraits<Registrar::RegistrarZoneAccessReply::Data>
{
    using ProtoType = Api::Registrar::RegistrarZoneAccessReply;
};

template <>
struct RegistryTypeTraits<Registrar::RegistrarZoneAccessReply::Exception::RegistrarDoesNotExist>
{
    using ProtoType = Api::Registrar::RegistrarZoneAccessReply;
};

}//namespace Fred::Registry
}//namespace Fred

#endif//PROTO_WRAP_HH_DFD8AE33A7CF17F901177987E210122D
